
static type_len fetch_scan_num(uint64 n_msgs, type_uid* n) {
  if (b0peek[0]!='*') return scan_uid(b0peek, (n));
  else {
    *n=(flag_uid? uil_nth(&msgs_all, n_msgs-1): n_msgs);
    return 1;
  }
}

typedef struct {
  VEC_T(unsigned int) sections;
  VEC_T(str) fields;
  enum { mime, text, header, header_fields, header_fields_not } type;
  type_bool partial;
  type_fsize begin, length;
} body_bits;
typedef VEC_T(body_bits) type_bbvec;

static void fetch_cleanup(type_bbvec* bbvec) {
  size_t i;
  for (i=0; i!=VEC_LEN(body_bits, bbvec); ++i) {
    body_bits* bb=VEC_ELTS(body_bits, bbvec)+i;
    str* fields=VEC_ELTS(str, &bb->fields);
    size_t nfields=VEC_LEN(str, &bb->fields);
    size_t j;
    for (j=0; j!=nfields; ++j) VEC_FREE(char, fields+j);
    VEC_FREE(str, &bb->fields);
    VEC_FREE(unsigned int, &bb->sections);
  }
  VEC_FREE(body_bits, bbvec);
}

/*keep open fd & sought offset for partial fetches*/ 
void imap_cmd_FETCH(void) {
  static type_uil msgs_selected=VEC_0(type_uid);
  type_bool flag_need_stat=0, flag_need_buffer=0, flag_need_cdb=0,
    flag_do_envelope=0, flag_do_flags=0, flag_do_body=0,
    flag_do_bodystructure=0, flag_do_internaldate=0, flag_do_rfc822=0,
    flag_do_rfc822_header=0, flag_do_rfc822_size=0, flag_do_rfc822_text=0,
    flag_do_body_all=0, flag_do_uid=flag_uid, flag_set_seen=0;
  uint64 n_msgs=uil_ct(&msgs_all);
  type_bbvec bbvec;
  type_uid i;
  type_len len;
  goto start;
  reject:
  fetch_cleanup(&bbvec);
  REJECT();
  start:
  uil_empty(&msgs_selected);
  if (!consumec(' ')) goto reject;
  for (;;) {
    type_uid msgi, msgj;
    len=fill_upto(": ,\n");
    if (len==0 || fetch_scan_num(n_msgs, &msgi)!=len) goto reject;
    b0seek(len);
    if (!consumec(':')) msgj=msgi;
    else {
      len=fill_upto(" ,\n");
      if (len==0 || fetch_scan_num(n_msgs, &msgj)!=len) goto reject;
      b0seek(len);
    }
    if (msgj<msgi) {
      type_uid tmp=msgj;
      msgj=msgi;
      msgi=tmp;
    }
    if (!flag_uid) {
      msgi=uil_nth(&msgs_all, (msgi<n_msgs? msgi: n_msgs)-1);
      msgj=uil_nth(&msgs_all, (msgj<n_msgs? msgj: n_msgs)-1);
    }
    if (uil_add_range(&msgs_selected, msgi, msgj)!=0) DIE0(alloc);
    if (!consumec(',')) break;
  }
  if (!consumec(' ')) goto reject;
#define CASE(x) (len==(sizeof #x)-1 && case_equalb(b0peek, (sizeof #x)-1, #x))
  len=fill_line_limit(16);
  if (CASE(all)) {
    flag_do_flags=
      flag_do_internaldate=
      flag_do_rfc822_size=
      flag_do_envelope=1;
  } else if (CASE(full)) {
    flag_do_flags=
      flag_do_internaldate=
      flag_do_rfc822_size=
      flag_do_envelope=
      flag_do_body=1;
  } else if (CASE(fast)) {
    flag_do_flags=
      flag_do_internaldate=
      flag_do_rfc822_size=1;
#undef CASE
  } else {
    type_bool flag_parens=consumec('(');
    if (flag_parens) { /* ) */ 
      buffer_unget(buffer_0, 1);
      b0peek[0]=' ';
    }
    while (!consumec(')')) {
      if (!consumec(' ')) goto reject;
      len=fill_upto(" )[\n");
      if (0) (void)0;
#define CASE1(attrname) CASE2(attrname,attrname)
#define CASE2(attrname,flagname) \
      else if (len==(sizeof #attrname)-1 && \
               consumeb(#attrname, (sizeof #attrname)-1)) \
        flag_do_##flagname=1
      CASE1(envelope);
      CASE1(flags);
      CASE1(internaldate);
      CASE1(uid);
      CASE1(rfc822);
      CASE2(rfc822.header, rfc822_header);
      CASE2(rfc822.size,   rfc822_size);
      CASE2(rfc822.text,   rfc822_text);
      CASE1(bodystructure);
#undef CASE1
#undef CASE2
      else if (!consumea("body")) goto reject;
      else if (b0peek[0]!='[' && b0peek[0]!='.') flag_do_body=1;
      else {
        body_bits* bb; /* body[]<1,2> */ 
        if (VEC_PUSHN(body_bits, &bbvec, NULLP, 1)!=0) DIE0(alloc);
        bb=VEC_ELTS(body_bits, &bbvec)+VEC_LEN(body_bits, &bbvec)-1;
        VEC_INIT(unsigned int, &bb->sections);
        VEC_INIT(str, &bb->fields);
        if (!consumea(".peek")) flag_set_seen=1;
        if (!consumec('[')) goto reject;
        if (consumec(']')) flag_do_body_all=1;
        else { 
          for (;;) {
            unsigned int section;
            fill_upto(".]\n");
            len=scan_uint(b0peek, &section);
            if (len==0) break;
            b0seek(len);
            if (VEC_PUSH1(unsigned int, &bb->sections, section)!=0)
              DIE0(alloc);
            if (!consumec('.')) goto reject;
          }
          if (VEC_LEN(unsigned int, &bb->sections)!=0 &&
              consumea("mime"))
            bb->type=mime;
          else if (consumea("text")) bb->type=text;
          else if (!consumea("header")) goto reject;
          else if (!consumea(".fields")) bb->type=header;
          else {
            bb->type=(consumea(".not")? header_fields_not: header_fields);
            if (!consumea(" (")) goto reject;
            buffer_unget(buffer_0, 1);
            b0peek[0]=' ';
            while (!consumec(')')) {
              str* field;
              if (VEC_PUSHN(str, &bb->fields, NULLP, 1)!=0) DIE0(alloc);
              field=VEC_ELTS(str, &bb->fields)+
                VEC_LEN(str, &bb->fields)-1;
              if (read_sp_astring(field, 0)!=0) goto reject;
            }
          }
          if (!consumec(']')) goto reject;
        }
        if (!consumec('<')) bb->partial=0;
        else {
          bb->partial=1;
          fill_upto(".>\n");
          scan_fsize(b0peek, &bb->begin); 
          if (!consumec('.')) bb->length=-1;
          else {
            fill_upto(">\n");
            scan_fsize(b0peek, &bb->length); 
          }
          if (!consumec('>')) goto reject;
        }
        /* <begin.end> */ 
      }
    }
  }
  END_ARGS();
debug("done parsing", b0peek, b0len);
  if (flag_do_internaldate || flag_do_rfc822 || flag_do_rfc822_header ||
      flag_do_rfc822_size)
    flag_need_stat=1;
  if (flag_do_rfc822 || flag_do_rfc822_header) flag_need_buffer=1;
  if (flag_do_envelope) flag_need_cdb=1;
  for (i=0; i!=n_msgs; ++i) {
    struct stat st;
    buffer msgbuf;
    type_fd fd;
    message_t const* msg=msg_list[i];
    type_uid_buf buf_uid;
    char sep[]="(";
    type_bool flag_do_flags_once=flag_do_flags;
    if (!msg->selected) continue;
debug("msg", "", 0);
    mustwrite("* ");
    FMT0(type_uid, &buf_uid, i+1);
    mustwrite(buf_uid);
    mustwrite(" FETCH ");
    VEC_TRUNC(char, &path, 0);
    must_n(&path, mb_selected->name, mb_selected->name_len);
    must_a(&path, "/new/", 1);
    must_n(&path, msg->name, msg->name_len+1);
    if (flag_need_stat)
      if (stat(s(&path), &st)!=0) { WARN1(stat, s(&path)); continue; }
    if (flag_need_buffer) {
      fd=open2(s(&path), O_RDONLY);
      if (fd<0) { WARN1(open, s(&path)); continue; }
      buffer_init(&msgbuf, &buffer_unixread, fd, buffer_space,
                  sizeof buffer_space);
    }
    if (flag_need_cdb) { 
    }
    if (flag_do_uid) {
      FMT0(type_uid, &buf_uid, msg->uid);
      writepart(sep, "UID ", buf_uid);
    }
    if (flag_do_envelope) { 
/*
envelope        ::= "(" env_date SPACE env_subject SPACE env_from
                    SPACE env_sender SPACE env_reply_to SPACE env_to
                    SPACE env_cc SPACE env_bcc SPACE env_in_reply_to
                    SPACE env_message_id ")"
env_bcc         ::= "(" 1*address ")" / nil
env_cc          ::= "(" 1*address ")" / nil
env_date        ::= nstring
env_from        ::= "(" 1*address ")" / nil
env_in_reply_to ::= nstring
env_message_id  ::= nstring
env_reply_to    ::= "(" 1*address ")" / nil
env_sender      ::= "(" 1*address ")" / nil
env_subject     ::= nstring
env_to          ::= "(" 1*address ")" / nil
address         ::= "(" addr_name SPACE addr_adl SPACE addr_mailbox
                    SPACE addr_host ")"
addr_adl        ::= nstring
                    ;; Holds route from [RFC-822] route-addr if
                    ;; non-NIL
addr_host       ::= nstring
                    ;; NIL indicates [RFC-822] group syntax.
                    ;; Otherwise, holds [RFC-822] domain name
addr_mailbox    ::= nstring
                    ;; NIL indicates end of [RFC-822] group; if
                    ;; non-NIL and addr_host is NIL, holds
                    ;; [RFC-822] group name.
                    ;; Otherwise, holds [RFC-822] local-part
addr_name       ::= nstring
                    ;; Holds phrase from [RFC-822] mailbox if
                    ;; non-NIL
*/
    }
    if (flag_do_body) { 
    }
    if (flag_do_bodystructure) { 
    }
    if (flag_do_internaldate) {
      struct tm* tm;
      tm=gmtime(&st.st_mtime);
      if (tm==NULLP) strerr_warn3x(PROG, "gmtime failed: ", s(&path));
      else {
        type_uint64_buf buf_date;
        static char months[12][4]=
          { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
            "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };
        FMT0(uint64, &buf_date, tm->tm_mday);
        writepart(sep, "INTERNALDATE \"", buf_date);
        mustwrite("-");
        mustwrite(months[tm->tm_mon]);
        mustwrite("-");
        FMT0(uint64, &buf_date, tm->tm_year+1900);
        mustwrite(buf_date);
        mustwrite(" ");
        FMT0(uint64, &buf_date, tm->tm_hour);
        if (buf_date[1]=='\0') mustwrite("0");
        mustwrite(buf_date);
        mustwrite(":");
        FMT0(uint64, &buf_date, tm->tm_min);
        if (buf_date[1]=='\0') mustwrite("0");
        mustwrite(buf_date);
        mustwrite(":");
        FMT0(uint64, &buf_date, tm->tm_sec);
        if (buf_date[1]=='\0') mustwrite("0");
        mustwrite(buf_date);
        mustwrite(" +0000\"");
      }
    }
    if (flag_do_rfc822) {
      type_fsize_buf buf_fsize;
      FMT0(type_fsize, &buf_fsize, st.st_size);
      writepart(sep, "RFC822 {", buf_fsize);
      mustwrite("}\r\n");
      if (buffer_flush(buffer_1)<0) DIE1(write, "network");
      for (;;) {
        type_len const len=must_fill(&msgbuf, s(&path));
        if (len==0) break;
        if (allwrite(1, buffer_RPEEK(&msgbuf), len)<len)
          DIE1(write, "network");
        buffer_RSEEK(&msgbuf, len);
      }
    }
    if (flag_do_rfc822_header) { 
/*
* x FETCH (BODY[HEADER] {46}
Content-Type: TEXT/PLAIN; CHARSET=US-ASCII

)
*/
    }
    if (flag_do_rfc822_size) {
      type_fsize_buf buf_fsize;
      FMT0(type_fsize, &buf_fsize, st.st_size);
      writepart(sep, "RFC822.SIZE ", buf_fsize);
    }
    if (flag_do_rfc822_text) { 
    }
    if (flag_do_flags_once) {
      char flagsep[]="(";
      writepart(sep, "FLAGS ", "");
#define CASE(f) if (msg->flag_##f) writepart(flagsep, "\\" #f, "")
      CASE(Seen);
      CASE(Answered);
      CASE(Flagged);
      CASE(Deleted);
      CASE(Draft);
      CASE(Recent);
#undef CASE
      if (flagsep[0]=='(') mustwrite(flagsep);
      mustwrite(")");
    }
    respond(")", NULLP, NULLP, NULLP, NULLP, NULLP);
    if (flag_need_buffer)
      if (fd_close(fd)!=0) DIE1(close, s(&path));
  }
  fetch_cleanup(&bbvec);
  RESPOND_OK_0();
}
