/* UID inversion lists */

VEC_TD(type_uid, type_uil);

typedef struct {
  type_uid elt;
  size_t i;
  type_uil const* uil;
} type_uil_iter;

/* Empties this inversion list. */
extern void uil_empty(type_uil*);
/* Adds this uid to this inversion list. */
extern type_status uil_add(type_uil*, type_uid);
/* Adds this range of uids (inclusive) to this inversion list. */
extern type_status uil_add_range(type_uil*, type_uid, type_uid);
/* Returns the number of uids in this inversion list. */
extern type_uid uil_ct(type_uil const*);
/* Tests whether this uid is in this inversion list. */
extern type_bool uil_member(type_uil const*, type_uid);
/* Returns the Nth uid in this inversion list, or 0 if there are too few
   entries. */
extern type_uid uil_nth(type_uil const*, size_t);
/* Returns the index of this uid in this inversion list. */
extern size_t uil_index(type_uil const*, type_uid);
/* Initialize an iterator for this inversion list. */
extern void uil_iter_init(type_uil_iter*, type_uil const*);
/* Advance this iterator to the next element and return 1, or return 0 if
   there is no next element. */
extern type_bool uil_iter_next(type_uil_iter*);
