#include "prjlibs-c/standards.h"
#include <stddef.h>

#include "prjlibs-c/vec.h"
#include "prjlibs-c/types.h"
#include "types.h"
#include "uil.h"

/* The last element in an inversion list is not a member of the set, so we
   wouldn't be able to make a list that includes the highest UID value.  To
   get around that, we store x-1 in the list to represent x.  UIDs can never
   be 0, so this doesn't cause any problms at the other end.
*/

type_status uil_add_range(type_uil* uil, type_uid uid0, type_uid uid1) {
  size_t i0, i1; /* array indices pointing to where uid0/1 should be inserted */
  size_t    const len =VEC_LEN (type_uid, uil);
  type_uid* const elts=VEC_ELTS(type_uid, uil);
  if (uid0>uid1 || uid0==0 || uid1==0) return (errno=EINVAL, -1);
  --uid0;
  for (i0=0;   i0!=len;) {        if (uid0<=elts[i0+1]) break; i0+=2; }
  for (i1=len; i1!=0;  ) { i1-=2; if (uid1>=elts[i1+0]) break;        }
  if (i0>i1 || i0==len || uid1<elts[i1+0]) {
    type_uid new_elts[]={ uid0, uid1 };
    return VEC_INSA(type_uid, uil, i0, new_elts, 0);
  } else {
    if (elts[i0+0]>uid0) elts[i0+0]=uid0;
    if (elts[i1+1]<uid1) elts[i1+1]=uid1;
    return VEC_CUTN(type_uid, uil, i0+1, NULL, i1-i0);
  }
}
